

def calcular_updowns (comps):
	ud = {}

	ups = 0
	for N in sorted (comps):
		compN = comps[N]
		downs = len (compN) - 1
		for palabra in compN:
			ud[palabra] = (ups, downs)
			ups += 1
			downs -= 1

	return ud


# ---------------- ejemplo ----------------
if __name__ == '__main__':

	largo, truncar = 2, 4
	comps = {2: [(1, 1)], 3: [(1, 2), (2, 1)], 4: [(1, 3), (2, 2), (3, 1)], 5:
		[(1, 4), (1, -4), (2, 3), (3, 2), (4, 1), (-4, 1)], 6: [(2, 4), (2, -4), (3,
		3), (4, 2), (-4, 2)], 7: [(3, 4), (3, -4), (4, 3), (-4, 3)], 8: [(4, 4), (4,
		-4), (-4, 4), (-4, -4)]}
	ud = calcular_updowns (comps)

	for N in sorted (comps):
		for palabra in comps[N]:
			print ('palabra=%s: ups, downs=%s' % (palabra, ud[palabra]))

