from __magnitud import magnitud


# composiciones posibles, agrupadas por su magnitud
def composiciones (palabras):
	comps = {}
	for p in palabras:
		N = magnitud (p)
		if not N in comps:
			comps[N] = []
		comps[N] += [p]

	return comps


# ----------------------------------------------------------------
if __name__ == '__main__':

	largo, truncar = 2, 4
	palabras = [(1, 1), (1, 2), (1, 3), (1, 4), (1, -4), (2, 1), (2, 2), (2, 3),
		(2, 4), (2, -4), (3, 1), (3, 2), (3, 3), (3, 4), (3, -4), (4, 1), (4, 2), (4,
		3), (4, 4), (4, -4), (-4, 1), (-4, 2), (-4, 3), (-4, 4), (-4, -4)]
	c = composiciones (palabras)

	for key in sorted (c):
		print ('N={0}: {1}'.format (key, c[key]))

