from hashlib import sha256, sha512


def expandir (m, bits, largo):
	H = sha512 if bits > 256 else sha256
	tbytes = (bits + 7) // 8

	r = []
	for n in range (largo):
		nHex = b'%x' % n
		h = H (nHex + m).digest ()[0:tbytes]
		r += [h]
	return r


# ----------------------------------------------------------------
if __name__ == '__main__':

	bits = 100
	m = b'abc'
	h = expandir (m, bits, 4)

	print ('# m = ' + repr (m))
	print ('# comprimir (m) = ' + repr (h))

